using System;
using System.Windows.Forms;

namespace Common
{
	class WinFormsKickstart
	{
		public event Action Loaded = delegate { };

		Form _Form;
		Control _Control;
		Timer _Timer;

		public WinFormsKickstart( Form form )
		{
			_Form = form;
			_Form.Load += StartTimer; // this reference keeps this instance alive
		}

		public WinFormsKickstart( Control control )
		{
			_Control = control;
			_Control.HandleCreated += StartTimer; // this reference keeps this instance alive
		}

		void StartTimer( object sender, EventArgs args )
		{
			_Timer = new Timer { Interval = 1 };
			_Timer.Tick += Tick;
			_Timer.Start();
		}

		void Tick( object sender, EventArgs args )
		{
			if ( _Timer == null ) return;

			_Timer.Dispose();
			_Timer = null;

			Loaded();

			// this instance can now be collected
			if ( _Form != null ) _Form.Load -= StartTimer;
			if ( _Control != null ) _Control.HandleCreated -= StartTimer;
		}
	}
}